<template>
  <div class="p-2">
    <transition :enter-active-class="proxy?.animate.searchAnimate.enter" :leave-active-class="proxy?.animate.searchAnimate.leave">
      <div class="search" v-show="showSearch">
        <el-form :model="queryParams" ref="queryFormRef" :inline="true" label-width="68px">
          <el-form-item label="产品名称" prop="productName">
            <el-input v-model="queryParams.productName" placeholder="请输入产品名称" clearable style="width: 240px" @keyup.enter="handleQuery" />
          </el-form-item>
          <el-form-item label="产品状态" prop="status">
            <el-select v-model="queryParams.status" placeholder="请选择产品状态" clearable style="width: 240px">
              <el-option
                v-for="dict in sys_common_status"
                :key="dict.value"
                :label="dict.label"
                :value="dict.value"
              />
            </el-select>
          </el-form-item>
          <el-form-item>
            <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
            <el-button icon="Refresh" @click="resetQuery">重置</el-button>
          </el-form-item>
        </el-form>
      </div>
    </transition>

    <el-card shadow="never">
      <template #header>
        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button type="primary" plain icon="Plus" @click="handleAdd()" v-hasPermi="['demo:product:add']">新增</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="info" plain icon="Sort" @click="handleToggleExpandAll">展开/折叠</el-button>
          </el-col>
          <right-toolbar v-model:showSearch="showSearch" @queryTable="getList"></right-toolbar>
        </el-row>
      </template>
      <el-table
        v-loading="loading"
        :data="productList"
        row-key="productId"
        :default-expand-all="isExpandAll"
        :tree-props="{children: 'children', hasChildren: 'hasChildren'}"
        ref="productTableRef"
      >
        <el-table-column label="产品名称" align="center" prop="productName" />
        <el-table-column label="显示顺序" align="center" prop="orderNum" />
        <el-table-column label="产品状态" align="center" prop="status">
          <template #default="scope">
            <dict-tag :options="sys_common_status" :value="scope.row.status"/>
          </template>
        </el-table-column>
        <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
          <template #default="scope">
            <el-tooltip content="修改" placement="top">
              <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)" v-hasPermi="['demo:product:edit']" />
            </el-tooltip>
            <el-tooltip content="新增" placement="top">
              <el-button link type="primary" icon="Plus" @click="handleAdd(scope.row)" v-hasPermi="['demo:product:add']" />
            </el-tooltip>
            <el-tooltip content="删除" placement="top">
              <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)" v-hasPermi="['demo:product:remove']" />
            </el-tooltip>
          </template>
        </el-table-column>
      </el-table>
    </el-card>
    <!-- 添加或修改产品树对话框 -->
    <el-dialog :title="dialog.title" v-model="dialog.visible" width="500px" append-to-body>
      <el-form ref="productFormRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="父产品id" prop="parentId">
          <el-tree-select
            v-model="form.parentId"
            :data="productOptions"
            :props="{ value: 'productId', label: 'productName', children: 'children' }"
            value-key="productId"
            placeholder="请选择父产品id"
            check-strictly
          />
        </el-form-item>
        <el-form-item label="产品名称" prop="productName">
          <el-input v-model="form.productName" placeholder="请输入产品名称" />
        </el-form-item>
        <el-form-item label="显示顺序" prop="orderNum">
          <el-input v-model="form.orderNum" placeholder="请输入显示顺序" />
        </el-form-item>
        <el-form-item label="产品状态" prop="status">
          <el-radio-group v-model="form.status">
            <el-radio
              v-for="dict in sys_common_status"
              :key="dict.value"
              :label="dict.value"
            >{{dict.label}}</el-radio>
          </el-radio-group>
        </el-form-item>
        <el-form-item label="乐观锁" prop="version" v-show="false">
          <el-input v-model="form.version" placeholder="请输入乐观锁" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="DemoProduct" lang="ts">
import { listProduct, getProduct, delProduct, addProduct, updateProduct } from "@/api/demo/product";
import { DemoProductVO, DemoProductQuery, DemoProductForm } from '@/api/demo/product/types';

type ProductOption = {
  productId: number;
  productName: string;
  children?: ProductOption[];
};

const { proxy } = getCurrentInstance() as ComponentInternalInstance;

const { sys_common_status } = toRefs<any>(proxy?.useDict('sys_common_status'));

const productList = ref<DemoProductVO[]>([]);
const productOptions = ref<ProductOption[]>([]);
const buttonLoading = ref(false);
const showSearch = ref(true);
const isExpandAll = ref(true);
const loading = ref(false);

const queryFormRef = ref<ElFormInstance>();
const productFormRef = ref<ElFormInstance>();
const productTableRef = ref<ElTableInstance>()

const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});


const initFormData: DemoProductForm = {
  productId: undefined,
  parentId: undefined,
  productName: undefined,
  orderNum: undefined,
  status: undefined,
  version: 0,
};

const data = reactive<PageData<DemoProductForm, DemoProductQuery>>({
  form: {...initFormData},
  queryParams: {
    productName: undefined,
    status: undefined,
    params: {
    }
  },
  rules: {
    parentId: [
      { required: true, message: "父产品id不能为空", trigger: "blur" }
    ],
    productName: [
      { required: true, message: "产品名称不能为空", trigger: "blur" }
    ],
    orderNum: [
      { required: true, message: "显示顺序不能为空", trigger: "blur" }
    ],
    status: [
      { required: true, message: "产品状态不能为空", trigger: "change" }
    ],
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询产品树列表 */
const getList = async () => {
  loading.value = true;
  const res = await listProduct(queryParams.value);
  const data = proxy?.handleTree<DemoProductVO>(res.data, 'productId', 'parentId');
  if (data) {
    productList.value = data;
    loading.value = false;
  }
};

/** 查询产品树下拉树结构 */
const getTreeselect = async () => {
  const res = await listProduct();
  productOptions.value = [];
  const data: ProductOption = { productId: 0, productName: '顶级节点', children: [] };
  data.children = proxy?.handleTree<ProductOption>(res.data, 'productId', 'parentId');
  productOptions.value.push(data);
};

// 取消按钮
const cancel = () => {
  reset();
  dialog.visible = false;
};

// 表单重置
const reset = () => {
  form.value = {...initFormData}
  productFormRef.value?.resetFields();
};

/** 搜索按钮操作 */
const handleQuery = () => {
  getList();
};

/** 重置按钮操作 */
const resetQuery = () => {
  queryFormRef.value?.resetFields();
  handleQuery();
};

/** 新增按钮操作 */
const handleAdd = (row?: DemoProductVO) => {
  reset();
  getTreeselect();
  if (row != null && row.productId) {
    form.value.parentId = row.productId;
  } else {
    form.value.parentId = 0;
  }
  dialog.visible = true;
  dialog.title = '添加产品树';
};

/** 展开/折叠操作 */
const handleToggleExpandAll = () => {
  isExpandAll.value = !isExpandAll.value;
  toggleExpandAll(productList.value, isExpandAll.value)
};

/** 展开/折叠操作 */
const toggleExpandAll = (data: DemoProductVO[], status: boolean) => {
  data.forEach((item) => {
    productTableRef.value?.toggleRowExpansion(item, status)
    if (item.children && item.children.length > 0) toggleExpandAll(item.children, status)
  })
};

/** 修改按钮操作 */
const handleUpdate = async (row: DemoProductVO) => {
  reset();
  await getTreeselect();
  if (row != null) {
    form.value.parentId = row.parentId;
  }
  const res = await getProduct(row.productId);
  Object.assign(form.value, res.data);
  dialog.visible = true;
  dialog.title = '修改产品树';
};

/** 提交按钮 */
const submitForm = () => {
  productFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      buttonLoading.value = true;
      if (form.value.productId) {
        await updateProduct(form.value).finally(() => buttonLoading.value = false);
      } else {
        await addProduct(form.value).finally(() => buttonLoading.value = false);
      }
      proxy?.$modal.msgSuccess('操作成功');
      dialog.visible = false;
      getList();
    }
  });
};

/** 删除按钮操作 */
const handleDelete = async (row: DemoProductVO) => {
  await proxy?.$modal.confirm('是否确认删除产品树编号为"' + row.productId + '"的数据项？');
  loading.value = true;
  await delProduct(row.productId).finally(() => loading.value = false);
  await getList();
  proxy?.$modal.msgSuccess('删除成功');
};

onMounted(() => {
  getList();
});
</script>
